/*
** Mime2AV
** 
** Eit enkelt program som vidaresender filer fr metamail til AV-serveren
**
** Jo Even Skarstein, 1997
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <aes.h>
#include <mintbind.h>
#include <string.h>

#ifndef TRUE
#define	TRUE	1
#define	FALSE	0
#endif

#define	VA_START	0x4711
#define	AV_VIEW		0x4751

#define	MGLOBAL			0x20

#define	AV	3

/*
** Makroar
*/

#define	AVSTR2MSG(msg,offset,str)	(*(char **)(msg+offset) = str)
#define	AVMSG2STR(msg,offset)			((char *)(((long)msg[offset]<<16)|(((long)msg[offset+1])&0xffff)))


/*
** Prototypes
*/

void unix2dos(char *streng);

/*
** MAIN
**
** argv[1]: temp-fila (m. path) som metamail angir.
** argv[2]: namnet til fila som angitt i mime-headeren.
**
** Kall opp Mime2AV slik: 'mime2av %s %{name}'
**
*/

int main(int argc, char *argv[])
{
	int my_apid, msg[8] = {VA_START,0,0,0,0,0,0,0}, avserver;
	char *AVtext = NULL, server[9]="        ", *temp,
		oldname[256], newname[256];

	/*
	** Avbryte dersom antal parameter ikkje stemmer
	*/
	if (argc > 3 || argc < 2)
	{
		Cconws("error parsing command-line!\n\r");
		return 0;
	}

	if (argv[1] = NULL || argv[2] == NULL)
		return 0;


	/*
	** MiNT domain
	*/
	Pdomain(1);

	/*
	** Initialisere AES-applikasjon
	*/
	my_apid = appl_init();
	if (my_apid == -1)
		return(FALSE);

	menu_register(my_apid,"  Mime2AV");

	/*
	** Finne evt. AV-server
	*/
	temp = getenv("AVSERVER");
	if (temp != NULL) {
		strncpy(server, temp, strlen(temp));
		avserver = appl_find(server); }


	/*
	** Allokere buffer til AV-msg. Bruk global-mem s vi ikkje fr
	** problem med mem-prot.
	*/
	AVtext = (char*) Mxalloc(256L, 0x0003|0x0028);
	if (AVtext == NULL) {
		Cconws("Unable to allocate memory for VA_START command-line!\n\r");
		appl_exit();
		return -1; }

	/*
	** OK, no skulle alt vere klart.
	*/
	
	/*
	** Gi fila nytt namn
	*/
	if (argc == AV) { /* Tre argument? */
		sprintf(oldname, "u:%s", argv[1]);
		unix2dos(oldname);
		sprintf(newname, "u:\\tmp\\%s", argv[2]);
		Fdelete(newname);
		if (Frename(0, oldname, newname) < 0) {
			Cconws("Couldn't rename file!\n\r");	
			Mfree(AVtext);
			appl_exit();
			return -1; }
		}
		else {
		sprintf(newname, "u:%s/%s", getenv("PWD"), argv[1]);
		unix2dos(newname); }

	/*
	** Sende VA_START til AV-serveren
	*/
	msg[2] = my_apid;
	AVSTR2MSG(msg,3,newname);
	appl_write(avserver, 16, msg);

	/*
	** Avslutte
	*/
	Mfree(AVtext);
	appl_exit();
	return 0;
}


/*
** unix2dos, konverterer fr / til \
*/

void unix2dos(char *streng)
{
	int teller = 0;

	while (streng[teller] != 0) {
		if (streng[teller] == '/')
			streng[teller] = '\\';
		++teller; }
}